language: go
go_import_path: github.com/ethereum/go-ethereum
sudo: false
matrix:
  include:
    - os: linux
      dist: trusty
      go: 1.5.4
      env:
        - GO15VENDOREXPERIMENT=1
    - os: linux
      dist: trusty
      go: 1.6.2
    - os: linux
      dist: trusty
      go: 1.7
    - os: osx
      go: 1.7

    # This builder does the Ubuntu PPA and Linux Azure uploads
    - os: linux
      dist: trusty
      sudo: required
      go: 1.7
      env:
        - ubuntu-ppa
        - azure-linux
      addons:
        apt:
          packages:
            - devscripts
            - debhelper
            - dput
            - gcc-multilib
      script:
        # Build for the primary platforms that Trusty can manage
        - go run build/ci.go debsrc -signer "Go Ethereum Linux Builder <geth-ci@ethereum.org>" -upload ppa:ethereum/ethereum
        - go run build/ci.go install
        - go run build/ci.go archive -type tar -signer LINUX_SIGNING_KEY -upload gethstore/builds
        - go run build/ci.go install -arch 386
        - go run build/ci.go archive -arch 386 -type tar -signer LINUX_SIGNING_KEY -upload gethstore/builds

        # Switch over GCC to cross compilation (breaks 386, hence why do it here only)
        - sudo -E apt-get -yq --no-install-suggests --no-install-recommends --force-yes install gcc-arm-linux-gnueabi libc6-dev-armel-cross gcc-arm-linux-gnueabihf libc6-dev-armhf-cross gcc-aarch64-linux-gnu libc6-dev-arm64-cross
        - sudo ln -s /usr/include/asm-generic /usr/include/asm

        - GOARM=5 CC=arm-linux-gnueabi-gcc go run build/ci.go install -arch arm
        - GOARM=5 go run build/ci.go archive -arch arm -type tar -signer LINUX_SIGNING_KEY -upload gethstore/builds
        - GOARM=6 CC=arm-linux-gnueabi-gcc go run build/ci.go install -arch arm
        - GOARM=6 go run build/ci.go archive -arch arm -type tar -signer LINUX_SIGNING_KEY -upload gethstore/builds
        - GOARM=7 CC=arm-linux-gnueabihf-gcc go run build/ci.go install -arch arm
        - GOARM=7 go run build/ci.go archive -arch arm -type tar -signer LINUX_SIGNING_KEY -upload gethstore/builds
        - CC=aarch64-linux-gnu-gcc go run build/ci.go install -arch arm64
        - go run build/ci.go archive -arch arm64 -type tar -signer LINUX_SIGNING_KEY -upload gethstore/builds

    # This builder does the OSX Azure, Android Maven and Azure and iOS CocoaPods and Azure uploads
    - os: osx
      go: 1.7
      env:
        - azure-osx
        - mobile
      cache:
        directories:
          - $HOME/.android.platforms
          - $HOME/.cocoapods
      script:
        - go run build/ci.go install
        - go run build/ci.go archive -type tar -signer OSX_SIGNING_KEY -upload gethstore/builds

        # Build the Android archive and upload it to Maven Central and Azure
        - brew update
        - brew install android-sdk maven gpg
        - alias gpg="gpg2"
        - export ANDROID_HOME=/usr/local/opt/android-sdk

        - mkdir -p $ANDROID_HOME/platforms
        - mv -f $HOME/.android.platforms $ANDROID_HOME/platforms
        - echo "y" | android update sdk --no-ui --filter `android list sdk | grep "SDK Platform Android" | grep -E 'API 15|API 19|API 24' | awk '{print $1}' | cut -d '-' -f 1 | tr '\n' ','`

        - go run build/ci.go aar -signer ANDROID_SIGNING_KEY -deploy https://oss.sonatype.org -upload gethstore/builds
        - mv -f $ANDROID_HOME/platforms $HOME/.android.platforms

        # Build the iOS framework and upload it to CocoaPods and Azure
        - gem uninstall cocoapods -a
        - gem install cocoapods --pre
        - xctool -version
        - xcrun simctl list
        - travis_wait 30 go run build/ci.go xcode -signer IOS_SIGNING_KEY -deploy trunk -upload gethstore/builds

install:
  - go get golang.org/x/tools/cmd/cover
script:
  - go run build/ci.go install
  - go run build/ci.go test -coverage -vet

notifications:
  webhooks:
    urls:
      - https://webhooks.gitter.im/e/e09ccdce1048c5e03445
    on_success: change
    on_failure: always
